package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.ApiClient;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.TypeRef;

import io.swagger.client.model.Pet;
import java.io.File;

import java.util.*;
import feign.*;

@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2015-12-01T16:10:23.565+08:00")
public interface PetApi extends io.swagger.client.ApiClient.Api {


  /**
   * Update an existing pet
   * 
   * @param body Pet object that needs to be added to the store
   * @return void
   */
  @RequestLine("PUT /pet")
  @Headers({
    
  })
  void updatePet (@Param("body") Pet body) throws ApiException;
  
  /**
   * Add a new pet to the store
   * 
   * @param body Pet object that needs to be added to the store
   * @return void
   */
  @RequestLine("POST /pet")
  @Headers({
    
  })
  void addPet (@Param("body") Pet body) throws ApiException;
  
  /**
   * Finds Pets by status
   * Multiple status values can be provided with comma seperated strings
   * @param status Status values that need to be considered for filter
   * @return List<Pet>
   */
  @RequestLine("GET /pet/findByStatus?status={status}")
  @Headers({
    
  })
  List<Pet> findPetsByStatus (@Param("status") List<String> status) throws ApiException;
  
  /**
   * Finds Pets by tags
   * Muliple tags can be provided with comma seperated strings. Use tag1, tag2, tag3 for testing.
   * @param tags Tags to filter by
   * @return List<Pet>
   */
  @RequestLine("GET /pet/findByTags?tags={tags}")
  @Headers({
    
  })
  List<Pet> findPetsByTags (@Param("tags") List<String> tags) throws ApiException;
  
  /**
   * Find pet by ID
   * Returns a pet when ID &lt; 10.  ID &gt; 10 or nonintegers will simulate API error conditions
   * @param petId ID of pet that needs to be fetched
   * @return Pet
   */
  @RequestLine("GET /pet/{petId}")
  @Headers({
    
  })
  Pet getPetById (@Param("petId") Long petId) throws ApiException;
  
  /**
   * Updates a pet in the store with form data
   * 
   * @param petId ID of pet that needs to be updated
   * @param name Updated name of the pet
   * @param status Updated status of the pet
   * @return void
   */
  @RequestLine("POST /pet/{petId}")
  @Headers({
    
  })
  void updatePetWithForm (@Param("petId") String petId, @Param("name") String name, @Param("status") String status) throws ApiException;
  
  /**
   * Deletes a pet
   * 
   * @param petId Pet id to delete
   * @param apiKey 
   * @return void
   */
  @RequestLine("DELETE /pet/{petId}")
  @Headers({
    "apiKey: {apiKey}"
  })
  void deletePet (@Param("petId") Long petId, @Param("apiKey") String apiKey) throws ApiException;
  
  /**
   * uploads an image
   * 
   * @param petId ID of pet to update
   * @param additionalMetadata Additional data to pass to server
   * @param file file to upload
   * @return void
   */
  @RequestLine("POST /pet/{petId}/uploadImage")
  @Headers({
    
  })
  void uploadFile (@Param("petId") Long petId, @Param("additionalMetadata") String additionalMetadata, @Param("file") File file) throws ApiException;
  
}
